#ifndef __CHB
#define  __CHB

#ifdef __cplusplus
extern "C" {
#endif

#define CHB_DEPTH_BEST       0
#define CHB_DEPTH_ANSI_3BIT  1
#define CHB_DEPTH_ANSI_4BIT  2
#define CHB_DEPTH_ANSI_8BIT  3
#define CHB_DEPTH_ANSI_24BIT 4
#define CHB_DEPTH_MS_CONSOLE 5

#define CHB_CHAR_BEST        0
#define CHB_CHAR_UTF8        1
#define CHB_CHAR_UTF16       2
#define CHB_CHAR_WIDE        3
#define CHB_CHAR_CP437       4

#define CHB_PALETTE_BEST     0

#define CHB_REPLACE_BEST     0


//single image output
void chb_print_image(unsigned int width, unsigned int height, unsigned char const * rgb_image);
void chb_print_image_opt(unsigned int CHB_DEPTH, unsigned int CHB_CHAR, unsigned int width, unsigned int height, unsigned char const * rgb_image);

//frame output
typedef struct chb_frame_state
{ void* state; } chb_frame_state;
void chb_init_frame(unsigned int width, unsigned int height, chb_frame_state* state);
void chb_free_frame(chb_frame_state * state);

void chb_print_frame(chb_frame_state * state, unsigned int width, unsigned int height, unsigned char const * rgb_image);
void chb_print_frame_opt(chb_frame_state * state, unsigned int CHB_DEPTH, unsigned int CHB_CHAR, unsigned int CHB_PALETTE, unsigned int CHB_REPLACE, unsigned int width, unsigned int height, unsigned char const * rgb_image);

#ifdef __cplusplus
}
#endif

#endif

