#ifndef __CLOSEST_LOWBIT
#define __CLOSEST_LOWBIT

#include <wchar.h>
#include <locale.h>
#include <stdlib.h>
#include <stdio.h>

#include "palette.h"

static void chb_closest_color_3(chb_rgb const * input_color, chb_palette_code * output_code)
{
	unsigned int best_diff = 0xffffffff;
	*output_code = 0;

	for(unsigned int code = 0; code<8; code++)
	{
		chb_rgb pal_color = chb_get_palette_3(code);
		unsigned int diff = chb_rgb_diff(input_color, &pal_color);

		if(diff < best_diff)
		{
			best_diff = diff;
			*output_code = code;
		}
	}
}

static void chb_closest_color_4(chb_rgb const * input_color, chb_palette_code * output_code)
{
	unsigned int best_diff = 0xffffffff;
	*output_code = 0;

	for(unsigned int code = 0; code<16; code++)
	{
		chb_rgb pal_color = chb_get_palette_4(code);
		unsigned int diff = chb_rgb_diff(input_color, &pal_color);

		if(diff < best_diff)
		{
			best_diff = diff;
			*output_code = code;
		}
	}
}

#endif
