#ifndef __CHB_OUTPUT
#define __CHB_OUTPUT
#include <stdlib.h>
#include <stdio.h>
#include "palette.h"
#include "rgb.h"
#include "closest_8bit.h"

#ifdef WIN32
#include <windows.h>
#endif

void chb_print_ansi_reset()
{ printf("\033[0m"); }

void chb_print_ansi4bit_code(unsigned char fg_ansi_code, unsigned char bg_ansi_code)
{ printf("\033[%d;%dm", fg_ansi_code, bg_ansi_code); }

void chb_print_ansi8bit_code(unsigned char fg_ansi_code, unsigned char bg_ansi_code)
{ printf("\033[38;5;%d;48;5;%dm", fg_ansi_code, bg_ansi_code); }

void chb_print_ansi24bit_code(chb_rgb const * fg_rgb, chb_rgb const * bg_rgb)
{
	unsigned char const * fg = fg_rgb->c;
	if(bg_rgb != NULL) {
		unsigned char const * bg = bg_rgb->c;
		printf("\033[38;2;%d;%d;%d;48;2;%d;%d;%dm", fg[0], fg[1], fg[2], bg[0], bg[1], bg[2]);
	}
	else
		printf("\033[38;2;%d;%d;%dm", fg[0], fg[1], fg[2]);
}

void chb_print_ansi4bit_nobg_code(unsigned char fg_ansi_code)
{ printf("\033[%dm", fg_ansi_code); }

void chb_print_ansi8bit_nobg_code(unsigned char fg_ansi_code)
{ printf("\033[38;5;%dm", fg_ansi_code); }

void chb_print_UHB_unicode_utf8()
{ printf("%c%c%c", 0xe2, 0x96, 0+128); }

void chb_print_UHB_unicode_utf16()
{ printf("%lc", 0x2580); }

void chb_print_UHB_cp_437()
{ printf("%c", 223); }

void chb_cursor_move_top_left()
{
#ifdef WIN32
	COORD coord;
	coord.X = 0;
	coord.Y = 0;
	HANDLE console = GetStdHandle(STD_OUTPUT_HANDLE);
	SetConsoleCursorPosition(console, coord);
#else
	printf("\033[1;1H");
#endif
}

#ifdef WIN32
void chb_set_ms4_code(WORD fg, WORD bg)
{
	HANDLE console = GetStdHandle(STD_OUTPUT_HANDLE);
	SetConsoleTextAttribute(console, fg | bg);
}

void chb_set_ms_reset_code()
{
	//Not a true reset- sets to white on black
	HANDLE console = GetStdHandle(STD_OUTPUT_HANDLE);
	SetConsoleTextAttribute(console, BACKGROUND_RED | BACKGROUND_GREEN | BACKGROUND_BLUE);
}
#endif


#endif
