#ifdef _MSC_VER
#define _CRT_SECURE_NO_WARNINGS
#endif

#include <stdlib.h>

#ifdef WIN32
#include <windows.h>
#include <gdiplus.h>
#endif

#include "view_impl.h"


void getGDIPImage(char const * filepath, size_t * out_width, size_t * out_height, unsigned char * * rgb_image)
{
	Gdiplus::GdiplusStartupInput gdiStartup;
	ULONG_PTR gdiToken;
	Gdiplus::GdiplusStartup(&gdiToken, &gdiStartup, NULL);

	WCHAR* wfp;
	int count = MultiByteToWideChar(CP_ACP, 0, filepath, -1, NULL, 0);
	wfp = new WCHAR[count];
	MultiByteToWideChar(CP_ACP, 0, filepath, -1, wfp, count);
	Gdiplus::Bitmap* bitmap = Gdiplus::Bitmap::FromFile(wfp);
	if (bitmap == NULL) {
		printf("Error opening %s\n", filepath);
		exit(1);
	}

	size_t height = bitmap->GetHeight();
	size_t width = bitmap->GetWidth();

	size_t size = height * width * 3 * sizeof(unsigned char);
	(*rgb_image) = (unsigned char*)malloc(size);
	if(*rgb_image == NULL) {
		printf("Could not allocate for image\n");
		exit(1);
	}

	Gdiplus::Color c;
	unsigned char r, g, b;
	for (size_t y = 0; y < height; y++)
	{
		for (size_t x = 0; x < width; x++)
		{
			size_t offset = (y*(width)+x) * 3;
			bitmap->GetPixel(x, y, &c);

			r = c.GetR();
			g = c.GetG();
			b = c.GetB();
			//printf("%d %d %d\n", r, g, b);
			(*rgb_image)[offset + 0] = r;
			(*rgb_image)[offset + 1] = g;
			(*rgb_image)[offset + 2] = b;
		}
	}

	*out_width = width;
	*out_height = height;

	Gdiplus::GdiplusShutdown(gdiToken);
}

int main(int argc, char ** argv)
{
	showImages(argc, argv, getGDIPImage);
	return 0;
}

